/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: nios2_system.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		Nios2ƥ
 *
 *  ڥեΥɥ쥹ֹ
 */

#ifndef TOPPERS_NIOS2_SYSTEM_H
#define TOPPERS_NIOS2_SYSTEM_H

#ifdef TOPPERS_NIOS2_DEV_2S180

/*
 *  NIOS2_DEV_2S180 Ѥ
 */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"NIOS2_DEV_2S180(NIOS2)"

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK		UINT_C(50000)

/*
 *  å奵
 */
#define NIOS2_ICACHE_SIZE			UINT_C(0x1000)   /* 4Kbyte */
#define NIOS2_ICACHE_LINE_SIZE		UINT_C(32)
#define NIOS2_DCACHE_SIZE			UINT_C(0)
#define NIOS2_DCACHE_LINE_SIZE		UINT_C(0)

/*
 *  Interval Timer
 */
#define SYS_CLK_TIMER_BASE	UINT_C(0x01001000)
#define SYS_CLK_TIMER_INT	UINT_C(0)

/*
 *  JTAG UART
 */
#define JTAG_UART_PORT1_BASE	UINT_C(0x010008a0)
#define JTAG_UART_PORT1_INT		UINT_C(1)

/*
 *  ƥС쥸Υ١ɥ쥹
 */
#define SYSVER_BASE				UINT_C(0x0f000000)

/*
 *  ƥС󻲾
 */
#define TNUM_HWCORE				UINT_C(1)           /*  */
#define MAJOR_VAR				UINT_C(5)           /* ᥸㡼С */

/*
 *  ٥ߥȥ
 */
#define VIC_BASE				UINT_C(0x01000c00)  /* ١ɥ쥹 */
#define VIC_INT_NUM				UINT_C(32)

#elif defined(TOPPERS_NIOS2_DEV_DE2_115)

/*
 *  NIOS2_DEV_DE2_115 Ѥ
 */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"NIOS2_DEV_DE2_115(NIOS2)"

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK		UINT_C(60000)

/*
 *  å奵
 */
#define NIOS2_ICACHE_SIZE			UINT_C(0x1000)   /* 4Kbyte */
#define NIOS2_ICACHE_LINE_SIZE		UINT_C(32)
#define NIOS2_DCACHE_SIZE			UINT_C(0)
#define NIOS2_DCACHE_LINE_SIZE		UINT_C(0)

/*
 *  Interval Timer
 */
#define SYS_CLK_TIMER_BASE	UINT_C(0x08000160)
#define SYS_CLK_TIMER_INT	UINT_C(0)

/*
 *  JTAG UART
 */
#define JTAG_UART_PORT1_BASE	UINT_C(0x080001a0)
#define JTAG_UART_PORT1_INT		UINT_C(1)

/*
 *  UART
 */
#define UART_PORT1_BASE	UINT_C(0x02000d00)
#define UART_PORT1_INT	UINT_C(3)

/*
 *  ƥС쥸Υ١ɥ쥹
 */
#define SYSVER_BASE				UINT_C(0x080001c0)

/*
 *  ƥС󻲾
 */
#define TNUM_HWCORE				UINT_C(1)           /*  */
#define MAJOR_VAR				UINT_C(7)           /* ᥸㡼С */

/*
 *  ٥ߥȥ
 */
#define VIC_BASE				UINT_C(0x0f000000)  /* ١ɥ쥹 */
#define VIC_INT_NUM				UINT_C(32)

#elif defined(TOPPERS_NIOS2_DEV_DE0_NANO)

/*
 *  NIOS2_DEV_DE2_115 Ѥ
 */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"NIOS2_DEV_DE0_NANO(NIOS2)"

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK		UINT_C(60000)

/*
 *  å奵
 */
#define NIOS2_ICACHE_SIZE			UINT_C(0x1000)   /* 4Kbyte */
#define NIOS2_ICACHE_LINE_SIZE		UINT_C(32)
#define NIOS2_DCACHE_SIZE			UINT_C(0)
#define NIOS2_DCACHE_LINE_SIZE		UINT_C(0)

/*
 *  Interval Timer
 */
#define SYS_CLK_TIMER_BASE	UINT_C(0x08000160)
#define SYS_CLK_TIMER_INT	UINT_C(0)

/*
 *  JTAG UART
 */
#define JTAG_UART_PORT1_BASE	UINT_C(0x080001a0)
#define JTAG_UART_PORT1_INT		UINT_C(1)

/*
 *  UART
 *  0x02000d00 = TTL level
 *  0x02000d40 = RS232C level
 */
#define UART_PORT1_BASE	UINT_C(0x02000d00)
#define UART_PORT1_INT	UINT_C(6)
//#define UART_PORT1_BASE	UINT_C(0x02000d40)
//#define UART_PORT1_INT	UINT_C(7)

/*
 *  ƥС쥸Υ١ɥ쥹
 */
#define SYSVER_BASE				UINT_C(0x080001c0)

/*
 *  ƥС󻲾
 */
#define TNUM_HWCORE				UINT_C(1)           /*  */
#define MAJOR_VAR				UINT_C(7)           /* ᥸㡼С */

/*
 *  ٥ߥȥ
 */
#define VIC_BASE				UINT_C(0x0f000000)  /* ١ɥ쥹 */
#define VIC_INT_NUM				UINT_C(32)

#endif /* TOPPERS_NIOS2_DEV_DE0_NANO */

/*
 *  ƥС쥸(sysver)
 */
#define SYSVER_MAJOR_VAR	(SYSVER_BASE + 0x00U)
#define SYSVER_MINOR_VAR	(SYSVER_BASE + 0x04U)
#define SYSVER_NUM_CORE		(SYSVER_BASE + 0x08U)

#endif /* TOPPERS_NIOS2_SYSTEM_H */
